package me.Demon.BungeeWarpPro.atp;


import me.Demon.BungeeWarpPro.Main;
import net.md_5.bungee.api.CommandSender;
import net.md_5.bungee.api.ProxyServer;
import net.md_5.bungee.api.chat.TextComponent;
import net.md_5.bungee.api.config.ServerInfo;
import net.md_5.bungee.api.connection.ProxiedPlayer;
import net.md_5.bungee.api.plugin.Command;
import net.md_5.bungee.api.plugin.TabExecutor;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class AtpCommand extends Command implements TabExecutor {

    public static Map<ProxiedPlayer, ProxiedPlayer> tpaMap = new HashMap<>();
    public static Map<ProxiedPlayer, ProxiedPlayer> playerMap = new HashMap<>();

    public AtpCommand() {
        super("atp");
    }

    @Override
    public void execute(CommandSender commandSender, String[] args) {
        if (!(commandSender instanceof ProxiedPlayer)) {
            return;
        }
        ProxiedPlayer player = (ProxiedPlayer) commandSender;
        if (args.length == 0) {
            TpaUtil.sendHelpMessage(player);
            return;
        }
        String target = args[0];
        if (target.equalsIgnoreCase("accept")) {
            accept(player);
        } else if (target.equalsIgnoreCase("deny")) {
            deny(player);
        } else {
            ProxiedPlayer player1 = ProxyServer.getInstance().getPlayer(target);
            if (player1 == null) {
                player.sendMessage(new TextComponent("§8§l[§c§l!§8§l] §7在战争领域大区中未找到 §a" + target));
            } else if (player.getUniqueId().equals(player1.getUniqueId())) {
                player.sendMessage(new TextComponent("§8§l[§c§l!§8§l] §7目标玩家不能是自己喔"));
            } else {
                String server_name = player1.getServer().getInfo().getName();
                System.out.print("目标所在区服： " + server_name);
                if (server_name.contains("sky")) {
                    tpa(player, player1, player1.getServer().getInfo());
                } else {
                    player.sendMessage(new TextComponent("§8§l[§c§l!§8§l] §7未在战争领域服务器中找到 §a" + target));
                }
            }
        }
    }

    private static void tpa(ProxiedPlayer player, ProxiedPlayer target, ServerInfo serverInfo) {
        tpaMap.put(player, target);
        playerMap.put(target, player);
        player.sendMessage(new TextComponent("§8§l[§a§l!§8§l] §7传送请求已发送至 §6" + target.getName()));
        TpaUtil.sendTargetMessage(player, target);
    }

    private static void accept(ProxiedPlayer player) {
        ProxiedPlayer player1 = playerMap.get(player);
        if (player1 == null || !player1.isConnected()) {
            player.sendMessage(new TextComponent("§8§l[§e§l!§8§l] §7没有待处理的传送请求"));
            return;
        }
        player.sendMessage(new TextComponent("§8§l[§e§l!§8§l] §7你接受了 §6" + player1.getName() + " §7的传送请求"));
        TpaUtil.sendAcceptMessage(player1, player);
        tpaMap.remove(player1);
        playerMap.remove(player);
        ServerInfo serverInfo = player.getServer().getInfo();
        boolean flag = false;
        if (player1.getServer().getInfo().equals(serverInfo)) {
            flag = true;
        } else {
            player1.connect(serverInfo);
        }
        boolean finalFlag = flag;
        TpaUtil.sendMessageToServer("accept", serverInfo, (dataOutputStream -> {
            try {
                dataOutputStream.writeUTF(player.getUniqueId().toString());
                dataOutputStream.writeUTF(player1.getUniqueId().toString());
                dataOutputStream.writeBoolean(finalFlag);
            } catch (Exception e) {
                e.printStackTrace();
            }
        }));
    }

    private static void deny(ProxiedPlayer player) {
        ProxiedPlayer player1 = playerMap.get(player);
        if (player1 == null || !player1.isConnected()) {
            player.sendMessage(new TextComponent("§8§l[§e§l!§8§l] §7没有待处理的传送请求"));
            return;
        }
        player.sendMessage(new TextComponent("§8§l[§c§l!§8§l] §7你拒绝 §6" + player1.getName() + " §7的传送请求"));
        TpaUtil.sendDenyMessage(player1, player);
        tpaMap.remove(player1);
        playerMap.remove(player);
    }

    @Override
    public Iterable<String> onTabComplete(CommandSender commandSender, String[] strings) {
        List<String> list = new ArrayList<>();
        Map<String, ServerInfo> hashMap = Main.getInstance().getProxy().getServers();
        for (String key : hashMap.keySet()) {
            String serverInfo = hashMap.get(key).getName();
            if (serverInfo.contains("chkdsc")) {
                hashMap.get(key).getPlayers().forEach(player -> list.add(player.getName()));
            }
        }
        return list;
    }
}
